(() => {
  const WIDTH = 14;
  require("FontTeletext5x9Ascii").add(Graphics);
  const buf = Graphics.createArrayBuffer(WIDTH,24,1,{msb:true}).setFont("Teletext5x9Ascii:1x2").setFontAlign(-1, 0);
  let pos = 0;
  let dir=-1;

  function scroll() {
    const date = new Date();
    const dateStr = require("locale").date(date, 1);
    const timeStr = require("locale").time(date, 1);
    const wid = WIDGETS.widclkscroll;
    const text = " " + dateStr + " " + timeStr + " ";
    buf.clear().drawString(text, pos, 12);
    if (dir === 1 && pos === 0 || dir === -1 && Math.abs(pos) === buf.stringWidth(text) - WIDTH) {
      dir*=-1;
    }
    pos+=dir;

    g.reset().drawImage({
      width:buf.getWidth(), height:buf.getHeight(),
      bpp:buf.getBPP(),
      buffer:buf.buffer
    }, wid.x+1, wid.y);
  }

  function run(on) {
    if (!Bangle.CLOCK) {
      const wid = WIDGETS.widclkscroll;
      if (on && !wid.interval) {
        wid.interval = setInterval(() => {
          scroll();
        }, 100);
        wid.width = WIDTH+2; Bangle.drawWidgets();
      } else if (!on && wid.interval) {
        clearInterval(wid.interval);
        wid.interval = undefined;
        wid.width = 0; Bangle.drawWidgets();
      }
    }
  }

  Bangle.on('lock', function(on) {
    run(!on);
  });

  function draw() {
    run(!Bangle.isLocked());
  }

  // add your widget
  WIDGETS["widclkscroll"]={
    area:"tl",
    width: 0, // default hide
    draw:draw
  };
})();
